Open CASCADE Technology: Prs3d_Drawer Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Attributes
Prs3d_Drawer Class Reference

A graphic attribute manager which governs how objects such as color, width, line thickness and deflection are displayed. A drawer includes an instance of the Aspect classes with particular default values. More...

`#include <Prs3d_Drawer.hxx>`

Inheritance diagram for Prs3d_Drawer:
[legend]

## Public Member Functions
| Prs3d_Drawer ()
| Default constructor. More...
void | SetTypeOfDeflection (const Aspect_TypeOfDeflection theTypeOfDeflection)
| Sets the type of chordal deflection. This indicates whether the deflection value is absolute or relative to the size of the object. More...
Aspect_TypeOfDeflection | TypeOfDeflection () const
| Returns the type of chordal deflection. This indicates whether the deflection value is absolute or relative to the size of the object. More...
Standard_Boolean | HasOwnTypeOfDeflection () const
| Returns true if the drawer has a type of deflection setting active. More...
void | SetMaximalChordialDeviation (const Quantity_Length theChordialDeviation)
| Defines the maximal chordial deviation when drawing any curve. Even if the type of deviation is set to TOD_Relative, this value is used by: Prs3d_DeflectionCurve Prs3d_WFDeflectionSurface Prs3d_WFDeflectionRestrictedFace. More...
Quantity_Length | MaximalChordialDeviation () const
| Returns the maximal chordal deviation. The default value is 0.1. Drawings of curves or patches are made with respect to an absolute maximal chordal deviation. More...
Standard_Boolean | HasOwnMaximalChordialDeviation () const
| Returns true if the drawer has a maximal chordial deviation setting active. More...
void | SetTypeOfHLR (const Prs3d_TypeOfHLR theTypeOfHLR)
| Sets the type of HLR algorithm used by drawer's interactive objects. More...
Prs3d_TypeOfHLR | TypeOfHLR ()
| Returns the type of HLR algorithm currently in use. More...
Standard_Boolean | HasOwnTypeOfHLR () const
| Returns true if the type of HLR is not equal to Prs3d_TOH_NotSet. More...
void | SetMaximalParameterValue (const Standard_Real theValue)
| Defines the maximum value allowed for the first and last parameters of an infinite curve. More...
Standard_Real | MaximalParameterValue () const
| Sets the maximum value allowed for the first and last parameters of an infinite curve. By default, this value is 500000. More...
Standard_Boolean | HasOwnMaximalParameterValue () const
| Returns true if the drawer has a maximum value allowed for the first and last parameters of an infinite curve setting active. More...
void | SetIsoOnPlane (const Standard_Boolean theIsEnabled)
| Sets IsoOnPlane on or off by setting the parameter theIsEnabled to true or false. More...
Standard_Boolean | IsoOnPlane () const
| Returns True if the drawing of isos on planes is enabled. More...
Standard_Boolean | HasOwnIsoOnPlane () const
| Returns true if the drawer has IsoOnPlane setting active. More...
void | SetDiscretisation (const Standard_Integer theValue)
| Sets the discretisation parameter theValue. More...
Standard_Integer | Discretisation () const
| Returns the discretisation setting. More...
Standard_Boolean | HasOwnDiscretisation () const
| Returns true if the drawer has discretisation setting active. More...
void | SetDeviationCoefficient (const Standard_Real theCoefficient)
| Sets the deviation coefficient theCoefficient. Also sets the hasOwnDeviationCoefficient flag to Standard_True and myPreviousDeviationCoefficient. More...
Standard_Real | DeviationCoefficient () const
| Returns the deviation coefficient. Drawings of curves or patches are made with respect to a maximal chordal deviation. A Deviation coefficient is used in the shading display mode. The shape is seen decomposed into triangles. These are used to calculate reflection of light from the surface of the object. The triangles are formed from chords of the curves in the shape. The deviation coefficient gives the highest value of the angle with which a chord can deviate from a tangent to a curve. If this limit is reached, a new triangle is begun. This deviation is absolute and is set through the method: SetMaximalChordialDeviation. The default value is 0.001. In drawing shapes, however, you are allowed to ask for a relative deviation. This deviation will be: SizeOfObject * DeviationCoefficient. More...
void | SetDeviationCoefficient ()
| Sets the hasOwnDeviationCoefficient flag to Standard_False. More...
Standard_Boolean | HasOwnDeviationCoefficient () const
| Returns true if there is a local setting for deviation coefficient in this framework for a specific interactive object. More...
Standard_Real | PreviousDeviationCoefficient () const
| Saves the previous value used for the chordal deviation coefficient. More...
void | SetHLRDeviationCoefficient (const Standard_Real theCoefficient)
| Sets the deviation coefficient aCoefficient for removal of hidden lines created by different viewpoints in different presentations. The Default value is 0.02. Also sets the hasOwnHLRDeviationCoefficient flag to Standard_True and myPreviousHLRDeviationCoefficient. More...
Standard_Real | HLRDeviationCoefficient () const
| Returns the real number value of the hidden line removal deviation coefficient in this framework, if the flag hasOwnHLRDeviationCoefficient is true or there is no Link. Else the shape's HLR deviation coefficient is used. A Deviation coefficient is used in the shading display mode. The shape is seen decomposed into triangles. These are used to calculate reflection of light from the surface of the object. The triangles are formed from chords of the curves in the shape. The deviation coefficient give the highest value of the angle with which a chord can deviate from a tangent to a curve. If this limit is reached, a new triangle is begun. To find the hidden lines, hidden line display mode entails recalculation of the view at each different projector perspective. Since hidden lines entail calculations of more than usual complexity to decompose them into these triangles, a deviation coefficient allowing greater tolerance is used. This increases efficiency in calculation. The Default value is 0.02. More...
void | SetHLRDeviationCoefficient ()
| Sets the hasOwnHLRDeviationCoefficient flag to Standard_False. More...
Standard_Boolean | HasOwnHLRDeviationCoefficient () const
| Returns true if the there is a setting for HLR deviation coefficient in this framework for a specific interactive object. More...
Standard_Real | PreviousHLRDeviationCoefficient () const
| Returns the previous value of the hidden line removal deviation coefficient. More...
void | SetDeviationAngle (const Standard_Real theAngle)
| Sets the deviation angle theAngle. Also sets the hasOwnDeviationAngle flag to Standard_True, and myPreviousDeviationAngle. More...
Standard_Real | DeviationAngle () const
| Returns the value for deviation angle. More...
void | SetDeviationAngle ()
| Sets the hasOwnDeviationAngle flag to Standard_False. More...
Standard_Boolean | HasOwnDeviationAngle () const
| Returns true if the there is a local setting for deviation angle in this framework for a specific interactive object. More...
Standard_Real | PreviousDeviationAngle () const
| Returns the previous deviation angle. More...
void | SetHLRAngle (const Standard_Real theAngle)
| Sets anAngle, the angle of maximum chordal deviation for removal of hidden lines created by different viewpoints in different presentations. The default value is 20 * M_PI / 180. Also sets the hasOwnHLRDeviationAngle flag to Standard_True and myPreviousHLRDeviationAngle. More...
Standard_Real | HLRAngle () const
| Returns the real number value of the deviation angle in hidden line removal views. The default value is 20 * M_PI / 180. More...
void | SetHLRAngle ()
| Sets the hasOwnHLRDeviationAngle flag to Standard_False. More...
Standard_Boolean | HasOwnHLRDeviationAngle () const
| Returns true if the there is a setting for HLR deviation angle in this framework for a specific interactive object. More...
Standard_Real | PreviousHLRDeviationAngle () const
| Returns the previous value of the HLR deviation angle. More...
void | SetAutoTriangulation (const Standard_Boolean theIsEnabled)
| Sets IsAutoTriangulated on or off by setting the parameter theIsEnabled to true or false. If this flag is True automatic re-triangulation with deflection-check logic will be applied. Else this feature will be disable and triangulation is expected to be computed by application itself and no shading presentation at all if unavailable. More...
Standard_Boolean | IsAutoTriangulation () const
| Returns True if automatic triangulation is enabled. More...
Standard_Boolean | HasOwnIsAutoTriangulation () const
| Returns true if the drawer has IsoOnPlane setting active. More...
const Handle< Prs3d_IsoAspect > & | UIsoAspect ()
| Defines the attributes which are used when drawing an U isoparametric curve of a face. Defines the number of U isoparametric curves to be drawn for a single face. The LineAspect for U isoparametric lines can be edited (methods SetColor, SetTypeOfLine, SetWidth, SetNumber) The default values are: COLOR : Quantity_NOC_GRAY75 TYPE OF LINE: Aspect_TOL_SOLID WIDTH : 0.5. More...
void | SetUIsoAspect (const Handle< Prs3d_IsoAspect > &theAspect)
Standard_Boolean | HasOwnUIsoAspect () const
| Returns true if the drawer has its own attribute for UIso aspect that overrides the one in the link. More...
const Handle< Prs3d_IsoAspect > & | VIsoAspect ()
| Defines the attributes which are used when drawing an V isoparametric curve of a face. Defines the number of V isoparametric curves to be drawn for a single face. The LineAspect for V isoparametric lines can be edited (methods SetColor, SetTypeOfLine, SetWidth, SetNumber) The default values are: COLOR : Quantity_NOC_GRAY82 TYPE OF LINE: Aspect_TOL_SOLID WIDTH : 0.5. More...
void | SetVIsoAspect (const Handle< Prs3d_IsoAspect > &theAspect)
| Sets the appearance of V isoparameters - theAspect. More...
Standard_Boolean | HasOwnVIsoAspect () const
| Returns true if the drawer has its own attribute for VIso aspect that overrides the one in the link. More...
const Handle< Prs3d_LineAspect > & | WireAspect ()
| Returns wire aspect settings. The LineAspect for the free boundaries can be edited. The default values are: Color: Quantity_NOC_GREEN Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the algorithm Prs3d_WFShape. More...
void | SetWireAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the parameter theAspect for display of wires. More...
Standard_Boolean | HasOwnWireAspect () const
| Returns true if the drawer has its own attribute for wire aspect that overrides the one in the link. More...
void | SetWireDraw (const Standard_Boolean theIsEnabled)
| Sets WireDraw on or off by setting the parameter theIsEnabled to true or false. More...
Standard_Boolean | WireDraw () const
| Returns True if the drawing of the wire is enabled. More...
Standard_Boolean | HasOwnWireDraw () const
| Returns true if the drawer has its own attribute for "draw wires" flag that overrides the one in the link. More...
const Handle< Prs3d_PointAspect > & | PointAspect ()
| Returns the point aspect setting. The default values are Color: Quantity_NOC_YELLOW Type of marker: Aspect_TOM_PLUS Scale: 1.0 These attributes are used by the algorithms Prs3d_Point. More...
void | SetPointAspect (const Handle< Prs3d_PointAspect > &theAspect)
| Sets the parameter theAspect for display attributes of points. More...
Standard_Boolean | HasOwnPointAspect () const
| Returns true if the drawer has its own attribute for point aspect that overrides the one in the link. More...
const Handle< Prs3d_LineAspect > & | LineAspect ()
| Returns settings for line aspects. These settings can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the following algorithms: Prs3d_Curve Prs3d_Line Prs3d_HLRShape. More...
void | SetLineAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the parameter theAspect for display attributes of lines. More...
Standard_Boolean | HasOwnLineAspect () const
| Returns true if the drawer has its own attribute for line aspect that overrides the one in the link. More...
const Handle< Prs3d_TextAspect > & | TextAspect ()
| Returns settings for text aspect. These settings can be edited. The default value is: More...
void | SetTextAspect (const Handle< Prs3d_TextAspect > &theAspect)
| Sets the parameter theAspect for display attributes of text. More...
Standard_Boolean | HasOwnTextAspect () const
| Returns true if the drawer has its own attribute for text aspect that overrides the one in the link. More...
const Handle< Prs3d_ShadingAspect > & | ShadingAspect ()
| Returns settings for shading aspects. These settings can be edited. The default values are: More...
void | SetShadingAspect (const Handle< Prs3d_ShadingAspect > &theAspect)
| Sets the parameter theAspect for display attributes of shading. More...
Standard_Boolean | HasOwnShadingAspect () const
| Returns true if the drawer has its own attribute for shading aspect that overrides the one in the link. More...
Standard_Boolean | ShadingAspectGlobal () const
| Returns True if the ShadingAspect is applied to the whole presentation. More...
void | SetShadingAspectGlobal (const Standard_Boolean theValue)
| Indicates that the ShadingAspect will be apply to the whole presentation. This allows to modify the aspect without recomputing the content of the presentation. More...
Standard_Boolean | HasOwnShadingAspectGlobal () const
| Returns true if the drawer has its own attribute for ShadingAspectGlobal flag that overrides the one in the link. More...
const Handle< Prs3d_LineAspect > & | SeenLineAspect ()
| Returns settings for seen line aspects. These settings can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_SOLID Width: 1.0. More...
void | SetSeenLineAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the parameter theAspect for the display of seen lines in hidden line removal mode. More...
Standard_Boolean | HasOwnSeenLineAspect () const
| Returns true if the drawer has its own attribute for seen line aspect that overrides the one in the link. More...
const Handle< Prs3d_PlaneAspect > & | PlaneAspect ()
| Returns settings for the appearance of planes. More...
void | SetPlaneAspect (const Handle< Prs3d_PlaneAspect > &theAspect)
| Sets the parameter theAspect for the display of planes. More...
Standard_Boolean | HasOwnPlaneAspect () const
| Returns true if the drawer has its own attribute for plane aspect that overrides the one in the link. More...
const Handle< Prs3d_ArrowAspect > & | ArrowAspect ()
| Returns the attributes for display of arrows. More...
void | SetArrowAspect (const Handle< Prs3d_ArrowAspect > &theAspect)
| Sets the parameter theAspect for display attributes of arrows. More...
Standard_Boolean | HasOwnArrowAspect () const
| Returns true if the drawer has its own attribute for arrow aspect that overrides the one in the link. More...
void | SetLineArrowDraw (const Standard_Boolean theIsEnabled)
| Enables the drawing of an arrow at the end of each line. By default the arrows are not drawn. More...
Standard_Boolean | LineArrowDraw () const
| Returns True if drawing an arrow at the end of each edge is enabled and False otherwise (the default). More...
Standard_Boolean | HasOwnLineArrowDraw () const
| Returns true if the drawer has its own attribute for "draw arrow" flag that overrides the one in the link. More...
const Handle< Prs3d_LineAspect > & | HiddenLineAspect ()
| Returns settings for hidden line aspects. These settings can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_DASH Width: 1.0. More...
void | SetHiddenLineAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the parameter theAspect for the display of hidden lines in hidden line removal mode. More...
Standard_Boolean | HasOwnHiddenLineAspect () const
| Returns true if the drawer has its own attribute for hidden lines aspect that overrides the one in the link. More...
Standard_Boolean | DrawHiddenLine () const
| Returns Standard_True if the hidden lines are to be drawn. By default the hidden lines are not drawn. More...
void | EnableDrawHiddenLine ()
| Enables the DrawHiddenLine function. More...
void | DisableDrawHiddenLine ()
| Disables the DrawHiddenLine function. More...
Standard_Boolean | HasOwnDrawHiddenLine () const
| Returns true if the drawer has its own attribute for "draw hidden lines" flag that overrides the one in the link. More...
const Handle< Prs3d_LineAspect > & | VectorAspect ()
| Returns settings for the appearance of vectors. These settings can be edited. The default values are: Color: Quantity_NOC_SKYBLUE Type of line: Aspect_TOL_SOLID Width: 1.0. More...
void | SetVectorAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the modality theAspect for the display of vectors. More...
Standard_Boolean | HasOwnVectorAspect () const
| Returns true if the drawer has its own attribute for vector aspect that overrides the one in the link. More...
void | SetVertexDrawMode (const Prs3d_VertexDrawMode theMode)
| Sets the mode of visualization of vertices of a TopoDS_Shape instance. By default, only stand-alone vertices (not belonging topologically to an edge) are drawn, that corresponds to Prs3d_VDM_Standalone mode. Switching to Prs3d_VDM_Standalone mode makes all shape's vertices visible. To inherit this parameter from the global drawer instance ("the link") when it is present, Prs3d_VDM_Inherited value should be used. More...
Prs3d_VertexDrawMode | VertexDrawMode ()
| Returns the current mode of visualization of vertices of a TopoDS_Shape instance. More...
Standard_Boolean | HasOwnVertexDrawMode () const
| Returns true if the vertex draw mode is not equal to Prs3d_VDM_Inherited. This means that individual vertex draw mode value (i.e. not inherited from the global drawer) is used for a specific interactive object. More...
const Handle< Prs3d_DatumAspect > & | DatumAspect ()
| Returns settings for the appearance of datums. These settings can be edited. The default values for the three axes are: Color: Quantity_NOC_PEACHPUFF Type of line: Aspect_TOL_SOLID Width: 1.0. More...
void | SetDatumAspect (const Handle< Prs3d_DatumAspect > &theAspect)
| Sets the modality theAspect for the display of datums. More...
Standard_Boolean | HasOwnDatumAspect () const
| Returns true if the drawer has its own attribute for datum aspect that overrides the one in the link. More...
const Handle< Prs3d_LineAspect > & | SectionAspect ()
| The LineAspect for the wire can be edited. The default values are: Color: Quantity_NOC_ORANGE Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the algorithm Prs3d_WFShape. More...
void | SetSectionAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the parameter theAspect for display attributes of sections. More...
Standard_Boolean | HasOwnSectionAspect () const
| Returns true if the drawer has its own attribute for section aspect that overrides the one in the link. More...
void | SetFreeBoundaryAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the parameter theAspect for the display of free boundaries. The method sets aspect owned by the drawer that will be used during visualization instead of the one set in link. More...
const Handle< Prs3d_LineAspect > & | FreeBoundaryAspect ()
| Returns the values for presentation of free boundaries, in other words, boundaries which are not shared. The LineAspect for the free boundaries can be edited. The default values are: Color: Quantity_NOC_GREEN Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the algorithm Prs3d_WFShape. More...
Standard_Boolean | HasOwnFreeBoundaryAspect () const
| Returns true if the drawer has its own attribute for free boundaries aspect that overrides the one in the link. More...
void | SetFreeBoundaryDraw (const Standard_Boolean theIsEnabled)
| Enables or disables drawing of free boundaries for shading presentations. The method sets drawing flag owned by the drawer that will be used during visualization instead of the one set in link. theIsEnabled is a boolean flag indicating whether the free boundaries should be drawn or not. More...
Standard_Boolean | FreeBoundaryDraw () const
| Returns True if the drawing of the free boundaries is enabled True is the default setting. More...
Standard_Boolean | HasOwnFreeBoundaryDraw () const
| Returns true if the drawer has its own attribute for "draw free boundaries" flag that overrides the one in the link. More...
void | SetUnFreeBoundaryAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets the parameter theAspect for the display of shared boundaries. The method sets aspect owned by the drawer that will be used during visualization instead of the one set in link. More...
const Handle< Prs3d_LineAspect > & | UnFreeBoundaryAspect ()
| Returns settings for shared boundary line aspects. The LineAspect for the unfree boundaries can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_SOLID Width: 1. These attributes are used by the algorithm Prs3d_WFShape. More...
Standard_Boolean | HasOwnUnFreeBoundaryAspect () const
| Returns true if the drawer has its own attribute for unfree boundaries aspect that overrides the one in the link. More...
void | SetUnFreeBoundaryDraw (const Standard_Boolean theIsEnabled)
| Enables or disables drawing of shared boundaries for shading presentations. The method sets drawing flag owned by the drawer that will be used during visualization instead of the one set in link. theIsEnabled is a boolean flag indicating whether the shared boundaries should be drawn or not. More...
Standard_Boolean | UnFreeBoundaryDraw () const
| Returns True if the drawing of the shared boundaries is enabled. True is the default setting. More...
Standard_Boolean | HasOwnUnFreeBoundaryDraw () const
| Returns true if the drawer has its own attribute for "draw shared boundaries" flag that overrides the one in the link. More...
void | SetFaceBoundaryAspect (const Handle< Prs3d_LineAspect > &theAspect)
| Sets line aspect for face boundaries. The method sets line aspect owned by the drawer that will be used during visualization instead of the one set in link. theAspect is the line aspect that determines the look of the face boundaries. More...
const Handle< Prs3d_LineAspect > & | FaceBoundaryAspect ()
| Returns line aspect of face boundaries. More...
Standard_Boolean | HasOwnFaceBoundaryAspect () const
| Returns true if the drawer has its own attribute for face boundaries aspect that overrides the one in the link. More...
void | SetFaceBoundaryDraw (const Standard_Boolean theIsEnabled)
| Enables or disables face boundary drawing for shading presentations. The method sets drawing flag owned by the drawer that will be used during visualization instead of the one set in link. theIsEnabled is a boolean flag indicating whether the face boundaries should be drawn or not. More...
Standard_Boolean | FaceBoundaryDraw () const
| Checks whether the face boundary drawing is enabled or not. More...
Standard_Boolean | HasOwnFaceBoundaryDraw () const
| Returns true if the drawer has its own attribute for "draw face boundaries" flag that overrides the one in the link. More...
const Handle< Prs3d_DimensionAspect > & | DimensionAspect ()
| Returns settings for the appearance of dimensions. More...
void | SetDimensionAspect (const Handle< Prs3d_DimensionAspect > &theAspect)
| Sets the settings for the appearance of dimensions. The method sets aspect owned by the drawer that will be used during visualization instead of the one set in link. More...
Standard_Boolean | HasOwnDimensionAspect () const
| Returns true if the drawer has its own attribute for the appearance of dimensions that overrides the one in the link. More...
void | SetDimLengthModelUnits (const TCollection_AsciiString &theUnits)
| Sets dimension length model units for computing of dimension presentation. The method sets value owned by the drawer that will be used during visualization instead of the one set in link. More...
void | SetDimAngleModelUnits (const TCollection_AsciiString &theUnits)
| Sets dimension angle model units for computing of dimension presentation. The method sets value owned by the drawer that will be used during visualization instead of the one set in link. More...
const TCollection_AsciiString & | DimLengthModelUnits () const
| Returns length model units for the dimension presentation. More...
const TCollection_AsciiString & | DimAngleModelUnits () const
| Returns angle model units for the dimension presentation. More...
Standard_Boolean | HasOwnDimLengthModelUnits () const
| Returns true if the drawer has its own attribute for dimension length model units that overrides the one in the link. More...
Standard_Boolean | HasOwnDimAngleModelUnits () const
| Returns true if the drawer has its own attribute for dimension angle model units that overrides the one in the link. More...
void | SetDimLengthDisplayUnits (const TCollection_AsciiString &theUnits)
| Sets length units in which value for dimension presentation is displayed. The method sets value owned by the drawer that will be used during visualization instead of the one set in link. More...
void | SetDimAngleDisplayUnits (const TCollection_AsciiString &theUnits)
| Sets angle units in which value for dimension presentation is displayed. The method sets value owned by the drawer that will be used during visualization instead of the one set in link. More...
const TCollection_AsciiString & | DimLengthDisplayUnits () const
| Returns length units in which dimension presentation is displayed. More...
const TCollection_AsciiString & | DimAngleDisplayUnits () const
| Returns angle units in which dimension presentation is displayed. More...
Standard_Boolean | HasOwnDimLengthDisplayUnits () const
| Returns true if the drawer has its own attribute for length units in which dimension presentation is displayed that overrides the one in the link. More...
Standard_Boolean | HasOwnDimAngleDisplayUnits () const
| Returns true if the drawer has its own attribute for angle units in which dimension presentation is displayed that overrides the one in the link. More...
const Handle< Prs3d_Drawer > & | Link ()
| Returns the drawer to which the current object references. More...
Standard_Boolean | HasLink () const
| Returns true if the current object has a link on the other drawer. More...
void | Link (const Handle< Prs3d_Drawer > &theDrawer)
| Sets theDrawer as a link to which the current object references. More...
void | ClearLocalAttributes ()
| Removes local attributes. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Protected Attributes
Handle< Prs3d_Drawer > | myLink
Standard_Integer | myNbPoints
Standard_Boolean | myHasOwnNbPoints
Standard_Real | myMaximalParameterValue
Standard_Boolean | myHasOwnMaximalParameterValue
Quantity_Length | myChordialDeviation
Standard_Boolean | myHasOwnChordialDeviation
Aspect_TypeOfDeflection | myTypeOfDeflection
Standard_Boolean | myHasOwnTypeOfDeflection
Prs3d_TypeOfHLR | myTypeOfHLR
Standard_Real | myDeviationCoefficient
Standard_Real | myPreviousDeviationCoefficient
Standard_Boolean | myHasOwnDeviationCoefficient
Standard_Real | myHLRDeviationCoefficient
Standard_Boolean | myHasOwnHLRDeviationCoefficient
Standard_Real | myPreviousHLRDeviationCoefficient
Standard_Real | myDeviationAngle
Standard_Boolean | myHasOwnDeviationAngle
Standard_Real | myPreviousDeviationAngle
Standard_Real | myHLRAngle
Standard_Boolean | myHasOwnHLRDeviationAngle
Standard_Real | myPreviousHLRDeviationAngle
Standard_Boolean | myIsoOnPlane
Standard_Boolean | myHasOwnIsoOnPlane
Standard_Boolean | myIsAutoTriangulated
Standard_Boolean | myHasOwnIsAutoTriangulated
Handle< Prs3d_IsoAspect > | myUIsoAspect
Standard_Boolean | myHasOwnUIsoAspect
Handle< Prs3d_IsoAspect > | myVIsoAspect
Standard_Boolean | myHasOwnVIsoAspect
Handle< Prs3d_LineAspect > | myWireAspect
Standard_Boolean | myHasOwnWireAspect
Standard_Boolean | myWireDraw
Standard_Boolean | myHasOwnWireDraw
Handle< Prs3d_PointAspect > | myPointAspect
Standard_Boolean | myHasOwnPointAspect
Handle< Prs3d_LineAspect > | myLineAspect
Standard_Boolean | myHasOwnLineAspect
Handle< Prs3d_TextAspect > | myTextAspect
Standard_Boolean | myHasOwnTextAspect
Handle< Prs3d_ShadingAspect > | myShadingAspect
Standard_Boolean | myHasOwnShadingAspect
Standard_Boolean | myShadingAspectGlobal
Standard_Boolean | myHasOwnShadingAspectGlobal
Handle< Prs3d_PlaneAspect > | myPlaneAspect
Standard_Boolean | myHasOwnPlaneAspect
Handle< Prs3d_LineAspect > | mySeenLineAspect
Standard_Boolean | myHasOwnSeenLineAspect
Handle< Prs3d_ArrowAspect > | myArrowAspect
Standard_Boolean | myHasOwnArrowAspect
Standard_Boolean | myLineArrowDraw
Standard_Boolean | myHasOwnLineArrowDraw
Handle< Prs3d_LineAspect > | myHiddenLineAspect
Standard_Boolean | myHasOwnHiddenLineAspect
Standard_Boolean | myDrawHiddenLine
Standard_Boolean | myHasOwnDrawHiddenLine
Handle< Prs3d_LineAspect > | myVectorAspect
Standard_Boolean | myHasOwnVectorAspect
Prs3d_VertexDrawMode | myVertexDrawMode
Handle< Prs3d_DatumAspect > | myDatumAspect
Standard_Boolean | myHasOwnDatumAspect
Handle< Prs3d_LineAspect > | mySectionAspect
Standard_Boolean | myHasOwnSectionAspect
Handle< Prs3d_LineAspect > | myFreeBoundaryAspect
Standard_Boolean | myHasOwnFreeBoundaryAspect
Standard_Boolean | myFreeBoundaryDraw
Standard_Boolean | myHasOwnFreeBoundaryDraw
Handle< Prs3d_LineAspect > | myUnFreeBoundaryAspect
Standard_Boolean | myHasOwnUnFreeBoundaryAspect
Standard_Boolean | myUnFreeBoundaryDraw
Standard_Boolean | myHasOwnUnFreeBoundaryDraw
Handle< Prs3d_LineAspect > | myFaceBoundaryAspect
Standard_Boolean | myHasOwnFaceBoundaryAspect
Standard_Boolean | myFaceBoundaryDraw
Standard_Boolean | myHasOwnFaceBoundaryDraw
Handle< Prs3d_DimensionAspect > | myDimensionAspect
Standard_Boolean | myHasOwnDimensionAspect
Prs3d_DimensionUnits | myDimensionModelUnits
Standard_Boolean | myHasOwnDimLengthModelUnits
Standard_Boolean | myHasOwnDimAngleModelUnits
Prs3d_DimensionUnits | myDimensionDisplayUnits
Standard_Boolean | myHasOwnDimLengthDisplayUnits
Standard_Boolean | myHasOwnDimAngleDisplayUnits

## Detailed Description

A graphic attribute manager which governs how objects such as color, width, line thickness and deflection are displayed. A drawer includes an instance of the Aspect classes with particular default values.

## Constructor & Destructor Documentation

Prs3d_Drawer::Prs3d_Drawer | ( |  | ) |

Default constructor.

## Member Function Documentation

const Handle< Prs3d_ArrowAspect >& Prs3d_Drawer::ArrowAspect | ( |  | ) |

Returns the attributes for display of arrows.

void Prs3d_Drawer::ClearLocalAttributes | ( |  | ) |

Removes local attributes.

const Handle< Prs3d_DatumAspect >& Prs3d_Drawer::DatumAspect | ( |  | ) |

Returns settings for the appearance of datums. These settings can be edited. The default values for the three axes are: Color: Quantity_NOC_PEACHPUFF Type of line: Aspect_TOL_SOLID Width: 1.0.

Standard_Real Prs3d_Drawer::DeviationAngle | ( |  | ) | const
| inline

Returns the value for deviation angle.

Standard_Real Prs3d_Drawer::DeviationCoefficient | ( |  | ) | const
| inline

Returns the deviation coefficient. Drawings of curves or patches are made with respect to a maximal chordal deviation. A Deviation coefficient is used in the shading display mode. The shape is seen decomposed into triangles. These are used to calculate reflection of light from the surface of the object. The triangles are formed from chords of the curves in the shape. The deviation coefficient gives the highest value of the angle with which a chord can deviate from a tangent to a curve. If this limit is reached, a new triangle is begun. This deviation is absolute and is set through the method: SetMaximalChordialDeviation. The default value is 0.001. In drawing shapes, however, you are allowed to ask for a relative deviation. This deviation will be: SizeOfObject * DeviationCoefficient.

const TCollection_AsciiString& Prs3d_Drawer::DimAngleDisplayUnits | ( |  | ) | const
| inline

Returns angle units in which dimension presentation is displayed.

const TCollection_AsciiString& Prs3d_Drawer::DimAngleModelUnits | ( |  | ) | const
| inline

Returns angle model units for the dimension presentation.

const Handle< Prs3d_DimensionAspect >& Prs3d_Drawer::DimensionAspect | ( |  | ) |

Returns settings for the appearance of dimensions.

const TCollection_AsciiString& Prs3d_Drawer::DimLengthDisplayUnits | ( |  | ) | const
| inline

Returns length units in which dimension presentation is displayed.

const TCollection_AsciiString& Prs3d_Drawer::DimLengthModelUnits | ( |  | ) | const
| inline

Returns length model units for the dimension presentation.

void Prs3d_Drawer::DisableDrawHiddenLine | ( |  | ) |

Disables the DrawHiddenLine function.

Standard_Integer Prs3d_Drawer::Discretisation | ( |  | ) | const
| inline

Returns the discretisation setting.

Standard_Boolean Prs3d_Drawer::DrawHiddenLine | ( |  | ) | const
| inline

Returns Standard_True if the hidden lines are to be drawn. By default the hidden lines are not drawn.

void Prs3d_Drawer::EnableDrawHiddenLine | ( |  | ) |

Enables the DrawHiddenLine function.

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::FaceBoundaryAspect | ( |  | ) |

Returns line aspect of face boundaries.

Standard_Boolean Prs3d_Drawer::FaceBoundaryDraw | ( |  | ) | const
| inline

Checks whether the face boundary drawing is enabled or not.

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::FreeBoundaryAspect | ( |  | ) |

Returns the values for presentation of free boundaries, in other words, boundaries which are not shared. The LineAspect for the free boundaries can be edited. The default values are: Color: Quantity_NOC_GREEN Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the algorithm Prs3d_WFShape.

Standard_Boolean Prs3d_Drawer::FreeBoundaryDraw | ( |  | ) | const
| inline

Returns True if the drawing of the free boundaries is enabled True is the default setting.

Standard_Boolean Prs3d_Drawer::HasLink | ( |  | ) | const
| inline

Returns true if the current object has a link on the other drawer.

Standard_Boolean Prs3d_Drawer::HasOwnArrowAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for arrow aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnDatumAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for datum aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnDeviationAngle | ( |  | ) | const
| inline

Returns true if the there is a local setting for deviation angle in this framework for a specific interactive object.

Standard_Boolean Prs3d_Drawer::HasOwnDeviationCoefficient | ( |  | ) | const
| inline

Returns true if there is a local setting for deviation coefficient in this framework for a specific interactive object.

Standard_Boolean Prs3d_Drawer::HasOwnDimAngleDisplayUnits | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for angle units in which dimension presentation is displayed that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnDimAngleModelUnits | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for dimension angle model units that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnDimensionAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for the appearance of dimensions that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnDimLengthDisplayUnits | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for length units in which dimension presentation is displayed that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnDimLengthModelUnits | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for dimension length model units that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnDiscretisation | ( |  | ) | const
| inline

Returns true if the drawer has discretisation setting active.

Standard_Boolean Prs3d_Drawer::HasOwnDrawHiddenLine | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for "draw hidden lines" flag that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnFaceBoundaryAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for face boundaries aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnFaceBoundaryDraw | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for "draw face boundaries" flag that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnFreeBoundaryAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for free boundaries aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnFreeBoundaryDraw | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for "draw free boundaries" flag that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnHiddenLineAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for hidden lines aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnHLRDeviationAngle | ( |  | ) | const
| inline

Returns true if the there is a setting for HLR deviation angle in this framework for a specific interactive object.

Standard_Boolean Prs3d_Drawer::HasOwnHLRDeviationCoefficient | ( |  | ) | const
| inline

Returns true if the there is a setting for HLR deviation coefficient in this framework for a specific interactive object.

Standard_Boolean Prs3d_Drawer::HasOwnIsAutoTriangulation | ( |  | ) | const
| inline

Returns true if the drawer has IsoOnPlane setting active.

Standard_Boolean Prs3d_Drawer::HasOwnIsoOnPlane | ( |  | ) | const
| inline

Returns true if the drawer has IsoOnPlane setting active.

Standard_Boolean Prs3d_Drawer::HasOwnLineArrowDraw | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for "draw arrow" flag that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnLineAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for line aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnMaximalChordialDeviation | ( |  | ) | const
| inline

Returns true if the drawer has a maximal chordial deviation setting active.

Standard_Boolean Prs3d_Drawer::HasOwnMaximalParameterValue | ( |  | ) | const
| inline

Returns true if the drawer has a maximum value allowed for the first and last parameters of an infinite curve setting active.

Standard_Boolean Prs3d_Drawer::HasOwnPlaneAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for plane aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnPointAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for point aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnSectionAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for section aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnSeenLineAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for seen line aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnShadingAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for shading aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnShadingAspectGlobal | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for ShadingAspectGlobal flag that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnTextAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for text aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnTypeOfDeflection | ( |  | ) | const
| inline

Returns true if the drawer has a type of deflection setting active.

Standard_Boolean Prs3d_Drawer::HasOwnTypeOfHLR | ( |  | ) | const
| inline

Returns true if the type of HLR is not equal to Prs3d_TOH_NotSet.

Standard_Boolean Prs3d_Drawer::HasOwnUIsoAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for UIso aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnUnFreeBoundaryAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for unfree boundaries aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnUnFreeBoundaryDraw | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for "draw shared boundaries" flag that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnVectorAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for vector aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnVertexDrawMode | ( |  | ) | const
| inline

Returns true if the vertex draw mode is not equal to Prs3d_VDM_Inherited. This means that individual vertex draw mode value (i.e. not inherited from the global drawer) is used for a specific interactive object.

Standard_Boolean Prs3d_Drawer::HasOwnVIsoAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for VIso aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnWireAspect | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for wire aspect that overrides the one in the link.

Standard_Boolean Prs3d_Drawer::HasOwnWireDraw | ( |  | ) | const
| inline

Returns true if the drawer has its own attribute for "draw wires" flag that overrides the one in the link.

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::HiddenLineAspect | ( |  | ) |

Returns settings for hidden line aspects. These settings can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_DASH Width: 1.0.

Standard_Real Prs3d_Drawer::HLRAngle | ( |  | ) | const
| inline

Returns the real number value of the deviation angle in hidden line removal views. The default value is 20 * M_PI / 180.

Standard_Real Prs3d_Drawer::HLRDeviationCoefficient | ( |  | ) | const
| inline

Returns the real number value of the hidden line removal deviation coefficient in this framework, if the flag hasOwnHLRDeviationCoefficient is true or there is no Link. Else the shape's HLR deviation coefficient is used. A Deviation coefficient is used in the shading display mode. The shape is seen decomposed into triangles. These are used to calculate reflection of light from the surface of the object. The triangles are formed from chords of the curves in the shape. The deviation coefficient give the highest value of the angle with which a chord can deviate from a tangent to a curve. If this limit is reached, a new triangle is begun. To find the hidden lines, hidden line display mode entails recalculation of the view at each different projector perspective. Since hidden lines entail calculations of more than usual complexity to decompose them into these triangles, a deviation coefficient allowing greater tolerance is used. This increases efficiency in calculation. The Default value is 0.02.

Standard_Boolean Prs3d_Drawer::IsAutoTriangulation | ( |  | ) | const
| inline

Returns True if automatic triangulation is enabled.

Standard_Boolean Prs3d_Drawer::IsoOnPlane | ( |  | ) | const
| inline

Returns True if the drawing of isos on planes is enabled.

Standard_Boolean Prs3d_Drawer::LineArrowDraw | ( |  | ) | const
| inline

Returns True if drawing an arrow at the end of each edge is enabled and False otherwise (the default).

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::LineAspect | ( |  | ) |

Returns settings for line aspects. These settings can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the following algorithms: Prs3d_Curve Prs3d_Line Prs3d_HLRShape.

const Handle< Prs3d_Drawer >& Prs3d_Drawer::Link | ( |  | ) |
| inline

Returns the drawer to which the current object references.

void Prs3d_Drawer::Link | ( | const Handle< Prs3d_Drawer > & | theDrawer | ) |
| inline

Sets theDrawer as a link to which the current object references.

Quantity_Length Prs3d_Drawer::MaximalChordialDeviation | ( |  | ) | const
| inline

Returns the maximal chordal deviation. The default value is 0.1. Drawings of curves or patches are made with respect to an absolute maximal chordal deviation.

Standard_Real Prs3d_Drawer::MaximalParameterValue | ( |  | ) | const
| inline

Sets the maximum value allowed for the first and last parameters of an infinite curve. By default, this value is 500000.

const Handle< Prs3d_PlaneAspect >& Prs3d_Drawer::PlaneAspect | ( |  | ) |

Returns settings for the appearance of planes.

const Handle< Prs3d_PointAspect >& Prs3d_Drawer::PointAspect | ( |  | ) |

Returns the point aspect setting. The default values are Color: Quantity_NOC_YELLOW Type of marker: Aspect_TOM_PLUS Scale: 1.0 These attributes are used by the algorithms Prs3d_Point.

Standard_Real Prs3d_Drawer::PreviousDeviationAngle | ( |  | ) | const
| inline

Returns the previous deviation angle.

Standard_Real Prs3d_Drawer::PreviousDeviationCoefficient | ( |  | ) | const
| inline

Saves the previous value used for the chordal deviation coefficient.

Standard_Real Prs3d_Drawer::PreviousHLRDeviationAngle | ( |  | ) | const
| inline

Returns the previous value of the HLR deviation angle.

Standard_Real Prs3d_Drawer::PreviousHLRDeviationCoefficient | ( |  | ) | const
| inline

Returns the previous value of the hidden line removal deviation coefficient.

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::SectionAspect | ( |  | ) |

The LineAspect for the wire can be edited. The default values are: Color: Quantity_NOC_ORANGE Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the algorithm Prs3d_WFShape.

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::SeenLineAspect | ( |  | ) |

Returns settings for seen line aspects. These settings can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_SOLID Width: 1.0.

void Prs3d_Drawer::SetArrowAspect | ( | const Handle< Prs3d_ArrowAspect > & | theAspect | ) |

Sets the parameter theAspect for display attributes of arrows.

void Prs3d_Drawer::SetAutoTriangulation | ( | const Standard_Boolean | theIsEnabled | ) |

Sets IsAutoTriangulated on or off by setting the parameter theIsEnabled to true or false. If this flag is True automatic re-triangulation with deflection-check logic will be applied. Else this feature will be disable and triangulation is expected to be computed by application itself and no shading presentation at all if unavailable.

void Prs3d_Drawer::SetDatumAspect | ( | const Handle< Prs3d_DatumAspect > & | theAspect | ) |

Sets the modality theAspect for the display of datums.

void Prs3d_Drawer::SetDeviationAngle | ( | const Standard_Real | theAngle | ) |

Sets the deviation angle theAngle. Also sets the hasOwnDeviationAngle flag to Standard_True, and myPreviousDeviationAngle.

void Prs3d_Drawer::SetDeviationAngle | ( |  | ) |
| inline

Sets the hasOwnDeviationAngle flag to Standard_False.

void Prs3d_Drawer::SetDeviationCoefficient | ( | const Standard_Real | theCoefficient | ) |

Sets the deviation coefficient theCoefficient. Also sets the hasOwnDeviationCoefficient flag to Standard_True and myPreviousDeviationCoefficient.

void Prs3d_Drawer::SetDeviationCoefficient | ( |  | ) |
| inline

Sets the hasOwnDeviationCoefficient flag to Standard_False.

void Prs3d_Drawer::SetDimAngleDisplayUnits | ( | const TCollection_AsciiString & | theUnits | ) |

Sets angle units in which value for dimension presentation is displayed. The method sets value owned by the drawer that will be used during visualization instead of the one set in link.

void Prs3d_Drawer::SetDimAngleModelUnits | ( | const TCollection_AsciiString & | theUnits | ) |

Sets dimension angle model units for computing of dimension presentation. The method sets value owned by the drawer that will be used during visualization instead of the one set in link.

void Prs3d_Drawer::SetDimensionAspect | ( | const Handle< Prs3d_DimensionAspect > & | theAspect | ) |

Sets the settings for the appearance of dimensions. The method sets aspect owned by the drawer that will be used during visualization instead of the one set in link.

void Prs3d_Drawer::SetDimLengthDisplayUnits | ( | const TCollection_AsciiString & | theUnits | ) |

Sets length units in which value for dimension presentation is displayed. The method sets value owned by the drawer that will be used during visualization instead of the one set in link.

void Prs3d_Drawer::SetDimLengthModelUnits | ( | const TCollection_AsciiString & | theUnits | ) |

Sets dimension length model units for computing of dimension presentation. The method sets value owned by the drawer that will be used during visualization instead of the one set in link.

void Prs3d_Drawer::SetDiscretisation | ( | const Standard_Integer | theValue | ) |

Sets the discretisation parameter theValue.

void Prs3d_Drawer::SetFaceBoundaryAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets line aspect for face boundaries. The method sets line aspect owned by the drawer that will be used during visualization instead of the one set in link. theAspect is the line aspect that determines the look of the face boundaries.

void Prs3d_Drawer::SetFaceBoundaryDraw | ( | const Standard_Boolean | theIsEnabled | ) |

Enables or disables face boundary drawing for shading presentations. The method sets drawing flag owned by the drawer that will be used during visualization instead of the one set in link. theIsEnabled is a boolean flag indicating whether the face boundaries should be drawn or not.

void Prs3d_Drawer::SetFreeBoundaryAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the parameter theAspect for the display of free boundaries. The method sets aspect owned by the drawer that will be used during visualization instead of the one set in link.

void Prs3d_Drawer::SetFreeBoundaryDraw | ( | const Standard_Boolean | theIsEnabled | ) |

Enables or disables drawing of free boundaries for shading presentations. The method sets drawing flag owned by the drawer that will be used during visualization instead of the one set in link. theIsEnabled is a boolean flag indicating whether the free boundaries should be drawn or not.

void Prs3d_Drawer::SetHiddenLineAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the parameter theAspect for the display of hidden lines in hidden line removal mode.

void Prs3d_Drawer::SetHLRAngle | ( | const Standard_Real | theAngle | ) |

Sets anAngle, the angle of maximum chordal deviation for removal of hidden lines created by different viewpoints in different presentations. The default value is 20 * M_PI / 180. Also sets the hasOwnHLRDeviationAngle flag to Standard_True and myPreviousHLRDeviationAngle.

void Prs3d_Drawer::SetHLRAngle | ( |  | ) |
| inline

Sets the hasOwnHLRDeviationAngle flag to Standard_False.

void Prs3d_Drawer::SetHLRDeviationCoefficient | ( | const Standard_Real | theCoefficient | ) |

Sets the deviation coefficient aCoefficient for removal of hidden lines created by different viewpoints in different presentations. The Default value is 0.02. Also sets the hasOwnHLRDeviationCoefficient flag to Standard_True and myPreviousHLRDeviationCoefficient.

void Prs3d_Drawer::SetHLRDeviationCoefficient | ( |  | ) |
| inline

Sets the hasOwnHLRDeviationCoefficient flag to Standard_False.

void Prs3d_Drawer::SetIsoOnPlane | ( | const Standard_Boolean | theIsEnabled | ) |

Sets IsoOnPlane on or off by setting the parameter theIsEnabled to true or false.

void Prs3d_Drawer::SetLineArrowDraw | ( | const Standard_Boolean | theIsEnabled | ) |

Enables the drawing of an arrow at the end of each line. By default the arrows are not drawn.

void Prs3d_Drawer::SetLineAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the parameter theAspect for display attributes of lines.

void Prs3d_Drawer::SetMaximalChordialDeviation | ( | const Quantity_Length | theChordialDeviation | ) |

Defines the maximal chordial deviation when drawing any curve. Even if the type of deviation is set to TOD_Relative, this value is used by: Prs3d_DeflectionCurve Prs3d_WFDeflectionSurface Prs3d_WFDeflectionRestrictedFace.

void Prs3d_Drawer::SetMaximalParameterValue | ( | const Standard_Real | theValue | ) |

Defines the maximum value allowed for the first and last parameters of an infinite curve.

void Prs3d_Drawer::SetPlaneAspect | ( | const Handle< Prs3d_PlaneAspect > & | theAspect | ) |

Sets the parameter theAspect for the display of planes.

void Prs3d_Drawer::SetPointAspect | ( | const Handle< Prs3d_PointAspect > & | theAspect | ) |

Sets the parameter theAspect for display attributes of points.

void Prs3d_Drawer::SetSectionAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the parameter theAspect for display attributes of sections.

void Prs3d_Drawer::SetSeenLineAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the parameter theAspect for the display of seen lines in hidden line removal mode.

void Prs3d_Drawer::SetShadingAspect | ( | const Handle< Prs3d_ShadingAspect > & | theAspect | ) |

Sets the parameter theAspect for display attributes of shading.

void Prs3d_Drawer::SetShadingAspectGlobal | ( | const Standard_Boolean | theValue | ) |

Indicates that the ShadingAspect will be apply to the whole presentation. This allows to modify the aspect without recomputing the content of the presentation.

void Prs3d_Drawer::SetTextAspect | ( | const Handle< Prs3d_TextAspect > & | theAspect | ) |

Sets the parameter theAspect for display attributes of text.

void Prs3d_Drawer::SetTypeOfDeflection | ( | const Aspect_TypeOfDeflection | theTypeOfDeflection | ) |

Sets the type of chordal deflection. This indicates whether the deflection value is absolute or relative to the size of the object.

void Prs3d_Drawer::SetTypeOfHLR | ( | const Prs3d_TypeOfHLR | theTypeOfHLR | ) |

Sets the type of HLR algorithm used by drawer's interactive objects.

void Prs3d_Drawer::SetUIsoAspect | ( | const Handle< Prs3d_IsoAspect > & | theAspect | ) |

void Prs3d_Drawer::SetUnFreeBoundaryAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the parameter theAspect for the display of shared boundaries. The method sets aspect owned by the drawer that will be used during visualization instead of the one set in link.

void Prs3d_Drawer::SetUnFreeBoundaryDraw | ( | const Standard_Boolean | theIsEnabled | ) |

Enables or disables drawing of shared boundaries for shading presentations. The method sets drawing flag owned by the drawer that will be used during visualization instead of the one set in link. theIsEnabled is a boolean flag indicating whether the shared boundaries should be drawn or not.

void Prs3d_Drawer::SetVectorAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the modality theAspect for the display of vectors.

void Prs3d_Drawer::SetVertexDrawMode | ( | const Prs3d_VertexDrawMode | theMode | ) |

Sets the mode of visualization of vertices of a TopoDS_Shape instance. By default, only stand-alone vertices (not belonging topologically to an edge) are drawn, that corresponds to Prs3d_VDM_Standalone mode. Switching to Prs3d_VDM_Standalone mode makes all shape's vertices visible. To inherit this parameter from the global drawer instance ("the link") when it is present, Prs3d_VDM_Inherited value should be used.

void Prs3d_Drawer::SetVIsoAspect | ( | const Handle< Prs3d_IsoAspect > & | theAspect | ) |

Sets the appearance of V isoparameters - theAspect.

void Prs3d_Drawer::SetWireAspect | ( | const Handle< Prs3d_LineAspect > & | theAspect | ) |

Sets the parameter theAspect for display of wires.

void Prs3d_Drawer::SetWireDraw | ( | const Standard_Boolean | theIsEnabled | ) |

Sets WireDraw on or off by setting the parameter theIsEnabled to true or false.

const Handle< Prs3d_ShadingAspect >& Prs3d_Drawer::ShadingAspect | ( |  | ) |

Returns settings for shading aspects. These settings can be edited. The default values are:

- Color: Quantity_NOC_YELLOW
- Material: Graphic3d_NOM_BRASS Shading aspect is obtained through decomposition of 3d faces into triangles, each side of each triangle being a chord of the corresponding curved edge in the face. Reflection of light in each projector perspective is then calculated for each of the resultant triangular planes.

Standard_Boolean Prs3d_Drawer::ShadingAspectGlobal | ( |  | ) | const
| inline

Returns True if the ShadingAspect is applied to the whole presentation.

const Handle< Prs3d_TextAspect >& Prs3d_Drawer::TextAspect | ( |  | ) |

Returns settings for text aspect. These settings can be edited. The default value is:

- Color: Quantity_NOC_YELLOW

Aspect_TypeOfDeflection Prs3d_Drawer::TypeOfDeflection | ( |  | ) | const
| inline

Returns the type of chordal deflection. This indicates whether the deflection value is absolute or relative to the size of the object.

Prs3d_TypeOfHLR Prs3d_Drawer::TypeOfHLR | ( |  | ) |

Returns the type of HLR algorithm currently in use.

const Handle< Prs3d_IsoAspect >& Prs3d_Drawer::UIsoAspect | ( |  | ) |

Defines the attributes which are used when drawing an U isoparametric curve of a face. Defines the number of U isoparametric curves to be drawn for a single face. The LineAspect for U isoparametric lines can be edited (methods SetColor, SetTypeOfLine, SetWidth, SetNumber) The default values are: COLOR : Quantity_NOC_GRAY75 TYPE OF LINE: Aspect_TOL_SOLID WIDTH : 0.5.

These attributes are used by the following algorithms: Prs3d_WFDeflectionSurface Prs3d_WFDeflectionRestrictedFace

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::UnFreeBoundaryAspect | ( |  | ) |

Returns settings for shared boundary line aspects. The LineAspect for the unfree boundaries can be edited. The default values are: Color: Quantity_NOC_YELLOW Type of line: Aspect_TOL_SOLID Width: 1. These attributes are used by the algorithm Prs3d_WFShape.

Standard_Boolean Prs3d_Drawer::UnFreeBoundaryDraw | ( |  | ) | const
| inline

Returns True if the drawing of the shared boundaries is enabled. True is the default setting.

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::VectorAspect | ( |  | ) |

Returns settings for the appearance of vectors. These settings can be edited. The default values are: Color: Quantity_NOC_SKYBLUE Type of line: Aspect_TOL_SOLID Width: 1.0.

Prs3d_VertexDrawMode Prs3d_Drawer::VertexDrawMode | ( |  | ) |

Returns the current mode of visualization of vertices of a TopoDS_Shape instance.

const Handle< Prs3d_IsoAspect >& Prs3d_Drawer::VIsoAspect | ( |  | ) |

Defines the attributes which are used when drawing an V isoparametric curve of a face. Defines the number of V isoparametric curves to be drawn for a single face. The LineAspect for V isoparametric lines can be edited (methods SetColor, SetTypeOfLine, SetWidth, SetNumber) The default values are: COLOR : Quantity_NOC_GRAY82 TYPE OF LINE: Aspect_TOL_SOLID WIDTH : 0.5.

These attributes are used by the following algorithms: Prs3d_WFDeflectionSurface Prs3d_WFDeflectionRestrictedFace

const Handle< Prs3d_LineAspect >& Prs3d_Drawer::WireAspect | ( |  | ) |

Returns wire aspect settings. The LineAspect for the free boundaries can be edited. The default values are: Color: Quantity_NOC_GREEN Type of line: Aspect_TOL_SOLID Width: 1.0 These attributes are used by the algorithm Prs3d_WFShape.

Standard_Boolean Prs3d_Drawer::WireDraw | ( |  | ) | const
| inline

Returns True if the drawing of the wire is enabled.

## Field Documentation

Handle< Prs3d_ArrowAspect > Prs3d_Drawer::myArrowAspect
| protected

Quantity_Length Prs3d_Drawer::myChordialDeviation
| protected

Handle< Prs3d_DatumAspect > Prs3d_Drawer::myDatumAspect
| protected

Standard_Real Prs3d_Drawer::myDeviationAngle
| protected

Standard_Real Prs3d_Drawer::myDeviationCoefficient
| protected

Handle< Prs3d_DimensionAspect > Prs3d_Drawer::myDimensionAspect
| protected

Prs3d_DimensionUnits Prs3d_Drawer::myDimensionDisplayUnits
| protected

Prs3d_DimensionUnits Prs3d_Drawer::myDimensionModelUnits
| protected

Standard_Boolean Prs3d_Drawer::myDrawHiddenLine
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::myFaceBoundaryAspect
| protected

Standard_Boolean Prs3d_Drawer::myFaceBoundaryDraw
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::myFreeBoundaryAspect
| protected

Standard_Boolean Prs3d_Drawer::myFreeBoundaryDraw
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnArrowAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnChordialDeviation
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDatumAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDeviationAngle
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDeviationCoefficient
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDimAngleDisplayUnits
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDimAngleModelUnits
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDimensionAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDimLengthDisplayUnits
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDimLengthModelUnits
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnDrawHiddenLine
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnFaceBoundaryAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnFaceBoundaryDraw
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnFreeBoundaryAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnFreeBoundaryDraw
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnHiddenLineAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnHLRDeviationAngle
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnHLRDeviationCoefficient
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnIsAutoTriangulated
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnIsoOnPlane
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnLineArrowDraw
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnLineAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnMaximalParameterValue
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnNbPoints
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnPlaneAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnPointAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnSectionAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnSeenLineAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnShadingAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnShadingAspectGlobal
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnTextAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnTypeOfDeflection
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnUIsoAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnUnFreeBoundaryAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnUnFreeBoundaryDraw
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnVectorAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnVIsoAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnWireAspect
| protected

Standard_Boolean Prs3d_Drawer::myHasOwnWireDraw
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::myHiddenLineAspect
| protected

Standard_Real Prs3d_Drawer::myHLRAngle
| protected

Standard_Real Prs3d_Drawer::myHLRDeviationCoefficient
| protected

Standard_Boolean Prs3d_Drawer::myIsAutoTriangulated
| protected

Standard_Boolean Prs3d_Drawer::myIsoOnPlane
| protected

Standard_Boolean Prs3d_Drawer::myLineArrowDraw
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::myLineAspect
| protected

Handle< Prs3d_Drawer > Prs3d_Drawer::myLink
| protected

Standard_Real Prs3d_Drawer::myMaximalParameterValue
| protected

Standard_Integer Prs3d_Drawer::myNbPoints
| protected

Handle< Prs3d_PlaneAspect > Prs3d_Drawer::myPlaneAspect
| protected

Handle< Prs3d_PointAspect > Prs3d_Drawer::myPointAspect
| protected

Standard_Real Prs3d_Drawer::myPreviousDeviationAngle
| protected

Standard_Real Prs3d_Drawer::myPreviousDeviationCoefficient
| protected

Standard_Real Prs3d_Drawer::myPreviousHLRDeviationAngle
| protected

Standard_Real Prs3d_Drawer::myPreviousHLRDeviationCoefficient
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::mySectionAspect
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::mySeenLineAspect
| protected

Handle< Prs3d_ShadingAspect > Prs3d_Drawer::myShadingAspect
| protected

Standard_Boolean Prs3d_Drawer::myShadingAspectGlobal
| protected

Handle< Prs3d_TextAspect > Prs3d_Drawer::myTextAspect
| protected

Aspect_TypeOfDeflection Prs3d_Drawer::myTypeOfDeflection
| protected

Prs3d_TypeOfHLR Prs3d_Drawer::myTypeOfHLR
| protected

Handle< Prs3d_IsoAspect > Prs3d_Drawer::myUIsoAspect
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::myUnFreeBoundaryAspect
| protected

Standard_Boolean Prs3d_Drawer::myUnFreeBoundaryDraw
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::myVectorAspect
| protected

Prs3d_VertexDrawMode Prs3d_Drawer::myVertexDrawMode
| protected

Handle< Prs3d_IsoAspect > Prs3d_Drawer::myVIsoAspect
| protected

Handle< Prs3d_LineAspect > Prs3d_Drawer::myWireAspect
| protected

Standard_Boolean Prs3d_Drawer::myWireDraw
| protected

The documentation for this class was generated from the following file:

- Prs3d_Drawer.hxx